﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace WpfApplication1
{

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class Stats : INotifyPropertyChanged
    {
        #region Properties

        #region String (INotifyPropertyChanged Property)
        private string _string;

        public string String
        {
            get { return _string; }
            set
            {
                _string = value;
                RaisePropertyChanged("String");
            }
        }
        #endregion
        #region PositionSize (INotifyPropertyChanged Property)
        private int _positionSize;

        public int PositionSize
        {
            get { return _positionSize; }
            set
            {
                _positionSize = value;
                RaisePropertyChanged("PositionSize");
            }
        }
        #endregion
        #region Price (INotifyPropertyChanged Property)
        private double _price;

        public double Price
        {
            get { return _price; }
            set
            {
                _price = value;
                RaisePropertyChanged("Price");
            }
        }
        #endregion
        #region Decimal (INotifyPropertyChanged Property)
        private decimal _decimal;

        public decimal Decimal
        {
            get { return _decimal; }
            set
            {
                _decimal = value;
                RaisePropertyChanged("Decimal");
            }
        }
        #endregion
        #region Boolean (INotifyPropertyChanged Property)
        private bool _boolean;

        public bool Boolean
        {
            get { return _boolean; }
            set
            {
                _boolean = value;
                RaisePropertyChanged("Boolean");
            }
        }
        #endregion
        #region DateTime (INotifyPropertyChanged Property)
        private DateTime _dateTime;

        public DateTime DateTime
        {
            get { return _dateTime; }
            set
            {
                _dateTime = value;
                RaisePropertyChanged("DateTime");
            }
        }
        #endregion
        #region Tag (INotifyPropertyChanged Property)
        private object _tag;

        public object Tag
        {
            get { return _tag; }
            set
            {
                _tag = value;
                RaisePropertyChanged("Tag");
            }
        }
        #endregion

        #endregion

        public Stats(int seed)
        {
            Random random = new Random(seed);
            this.String = RandomString(random.Next(5, 10));
            this.PositionSize = random.Next();
            this.Price = random.NextDouble();
            this.Decimal = seed;
            this.DateTime = DateTime.Now.AddDays(seed);
            this.Boolean = seed % 2 == 0;
        }

        public static IEnumerable<Stats> GetStats(int number)
        {
            var source = new List<Stats>();
            for (int i = 0; i < number; i++)
            {
                source.Add(new Stats(i));
            }
            return source;
        }

        #region INotifyPropertyChanged values

        public event global::System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new global::System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion

        private static string RandomString(int size)
        {
            StringBuilder builder = new StringBuilder();
            Random seed = new Random((int)DateTime.Now.Millisecond);
            System.Threading.Thread.Sleep(1);
            Random random = new Random(seed.Next(0, 1000));
            char ch;
            for (int i = 0; i < size; i++)
            {
                ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
                builder.Append(ch);
            }
            return builder.ToString();
        }
    }


    public class StatDataSet
    {
        private static int _instancesCount = 0;


        public StatDataSet(IEnumerable<Stats> chidren)
        {
            this.InstanceId = StatDataSet._instancesCount++;
            this.Status = this.InstanceId%3;

            //this.ChildrenItems = chidren;
        }
        public int InstanceId { get; set; }
        public int Status { get; set; }

        //public IEnumerable<Stats> ChildrenItems { get; set; }
    }
}
